﻿Type=Class
Version=5.02
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Private Sub Class_Globals
	Private MeasureHeightOfText As StringUtils 
	
	Private WidthOfLineBefore , WidthOfLineAfter , WidthRatioBefore , WidthRatioAfter , Rate , HeightOfText , HeightOfOneLine , Extra , LS As Float : Extra = 0
	Private linecount As Int	
	
	Private Jo , Paint As JavaObject
	Private Bounds As Rect
	Private R As Reflector

End Sub

Public Sub Initialize

End Sub

'Fit your text in view as long as the height of text is NOT greater than height of the view
'The text will be always one line
'CanBeLarger : if this option be false then your text will be fitted just if your text is more than 1 line
'
'Example :
'Dim T8TextSize1 as T8TextSize
'	T8TextSize1.Initialize
'	T8TextSize1.SingleLineFitText(TextView , True)
Public Sub SingleLineFitText(TargetView As Object,CanBeLarger As Boolean)
	Dim lbl As Label = TargetView 
		
		'measure space between lines (if be larger than 1 line)
		LS = GetLineSpacingMultiplier(TargetView)
		
		'when our text is still 1 line and we dont want to increase text size
		If (getLineCount(TargetView , LS) = 1) And (CanBeLarger = False) Then Return
			'set maximum text size 
			lbl.TextSize = 72 
			Rate = lbl.TextSize
			
			'measure height of text
			HeightOfText = getTextHeight(lbl)
		
			'measure line count
			linecount = getLineCount(lbl,LS)
			
			'set text size in a while loop
			Do While Rate > 0.5 Or linecount > 1 Or HeightOfText > lbl.Height
				Rate = Rate / 2	
					If HeightOfText > lbl.Height Or linecount > 1 Then 
						lbl.TextSize = lbl.TextSize - Rate
					Else 
						lbl.TextSize = lbl.TextSize + Rate
					End If		
					
					'measure height and line count with new text size
					HeightOfText = getTextHeight(lbl)
					linecount = getLineCount(lbl,LS)		
			Loop

End Sub

'Set spaces between lines
'
'Example :
'Dim T8TextSize1 as T8TextSize
'	T8TextSize1.Initialize
'	T8TextSize1.SetLineSpace(TextView ,0.75)
Public Sub SetLineSpace(TargetView As Object, Multiplier As Float)
	Jo = TargetView : Jo.RunMethod("setLineSpacing", Array As Object(Extra, Multiplier))
 End Sub
Private Sub GetLineSpacingMultiplier(TargetView As Object) As Float
    Jo = TargetView
    Return Jo.RunMethod("getLineSpacingMultiplier", Null)
End Sub

Private Sub getTextHeight(TargetView As Label) As Float
	Return MeasureHeightOfText.MeasureMultilineTextHeight(TargetView,TargetView.Text)
End Sub

Private Sub getLineCount(TargetView As Object,LineSpace As Float) As Int
	'measure line count
	Jo = TargetView 
	HeightOfOneLine = Jo.RunMethod("getLineHeight",Null) : HeightOfText = getTextHeight(TargetView) * LineSpace 
	
	'return line count
	Return Round(HeightOfText/HeightOfOneLine)	

'========================================================	
'===========THIS CODE NOT WORKED ON WHILE LOOP===========
'========================================================
'private Sub getLineCount(TargetView As Object) As Int
'	Jo = TargetView
'	Return Jo.RunMethod("getLineCount",Null)
'End Sub
'========================================================
'========================================================
'========================================================
End Sub